// hellowindow.h


/* Client Name */
char UIClientName[6] = "TOSUI";
char UIPipeName[16] = "\\\\.\\pipe\\TOSUI";



class CHelloWindow : public CFrameWnd
{
public:
	CHelloWindow();
	~CHelloWindow();
	afx_msg void OnExit();




private:

	
	/* ServerPipe */
	HANDLE pipe;

	/*ServerConnect Flag */
	bool Connect;

	/* Track Definition */
	Track myTrack;

	/* Timer Handle */
	UINT timer;

	/* Trains */
	Train * m_pTrains;
	unsigned long m_iTrains;

	/*Timer Function*/
	afx_msg void OnTimer( UINT nIDEvent );

		
	COLORREF m_color;
	CClientDC *m_pDC;
	
	/* Memory dc for drawing track viewport */
	CDC * m_pMemDC;
	CBitmap * m_pBM;
	CRect m_rTrackView;

	bool m_bAddTrain;
	int m_iScale;
	int m_iAddHoverSection;
	int m_iAddHoverLR;

	bool m_bAddIsHover;


	/* My Functions */
	void DrawTrackViewport();


	/* WINDOW EVENTS */	
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnClearTrack();
	afx_msg void OnLoadTrackFile();
	afx_msg void OnTestDccRequestUpdates();
	afx_msg void OnTestDccInit();
	afx_msg void OnTestDccTrain48();
	afx_msg void OnTestDccSetTurn();
	afx_msg void OnTestDccCab();
	afx_msg void OnTestRequestResource();
	afx_msg void OnTestReleaseResource();
	afx_msg void OnTestResourceUpdates();
	afx_msg void OnAddTrain();
	afx_msg void OnTestTrainUpdates();

	afx_msg void OnLButtonUp( UINT, CPoint );
	afx_msg void OnMouseMove( UINT, CPoint );


	/* TESTING FUNCTIONS */
	afx_msg void OnTestTrackManRequestData();
	afx_msg void OnTestTrackManRequestUpdates();


	/* MESSAGE MAP MACRO */
	DECLARE_MESSAGE_MAP()
};